import { setup, props } from '@opentiny/vue-common';
import { renderless, api } from '@opentiny/vue-renderless/loading/vue';
import '@opentiny/vue-theme-mobile/loading/index.css';
import { iconDotDownload } from '@opentiny/vue-icon';
import { resolveComponent, openBlock, createElementBlock, createVNode, createElementVNode, toDisplayString, createTextVNode } from 'vue';

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var script = {
  components: {
    iconDotDownload: iconDotDownload()
  },
  props: [].concat(_toConsumableArray(props), ['type', 'loadtext']),
  setup: function setup$1(props, context) {
    return setup({
      props: props,
      context: context,
      renderless: renderless,
      api: api
    });
  }
};

var _hoisted_1 = {
  key: 0,
  class: "tiny-mobile-loading-primary"
};
var _hoisted_2 = {
  key: 1,
  class: "tiny-mobile-loading-simple"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_dot_download = resolveComponent("icon-dot-download");
  return openBlock(), createElementBlock("div", null, [_ctx.state.type === 'primary' ? (openBlock(), createElementBlock("div", _hoisted_1, [createVNode(_component_icon_dot_download), createElementVNode("div", null, toDisplayString(_ctx.t($props.loadtext)), 1)])) : (openBlock(), createElementBlock("div", _hoisted_2, [createTextVNode(toDisplayString(_ctx.t($props.loadtext)) + " ", 1), createVNode(_component_icon_dot_download)]))]);
}

script.render = render;

export { script as default };
