import { setup, props } from '@opentiny/vue-common';
import { renderless, api } from '@opentiny/vue-renderless/loading/vue';
import { createElementVNode, openBlock, createBlock, Transition, withCtx, withDirectives, normalizeClass, normalizeStyle, createElementBlock, resolveDynamicComponent, toDisplayString, createCommentVNode, vShow } from 'vue';

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".tiny-loading{--ti-loading-text-color:var(--ti-base-color-brand-6);--ti-loading-mask-bg-color:rgba(255, 255, 255, 0.9);--ti-loading-text-font-size:var(--ti-common-font-size-1);--ti-loading-spinner-height:42px;--ti-loading-spinner-width:42px;--ti-loading-fullscreen-height:50px;--ti-loading-fullscreen-width:50px}.tiny-loading__mask{position:absolute;z-index:2000;background-color:var(--ti-loading-mask-bg-color);margin:0;top:0;right:0;bottom:0;left:0;-webkit-transition:opacity .3s;transition:opacity .3s}.tiny-loading__mask.is-fullscreen{position:fixed}.tiny-loading__mask.is-fullscreen .tiny-loading__spinner{margin-top:-25px}.tiny-loading__mask.is-fullscreen .tiny-loading__spinner .circular{height:var(--ti-loading-fullscreen-height);width:var(--ti-loading-fullscreen-width)}.tiny-loading__spinner{top:50%;margin-top:-21px;width:100%;text-align:center;position:absolute}.tiny-loading__spinner .tiny-loading__text{color:var(--ti-loading-text-color);margin:3px 0;font-size:var(--ti-loading-text-font-size)}.tiny-loading__spinner .circular{height:var(--ti-loading-spinner-height);width:var(--ti-loading-spinner-width);-webkit-animation:loading-rotate 2s linear infinite;animation:loading-rotate 2s linear infinite}.tiny-loading__spinner .path{-webkit-animation:loading-dash 1.5s ease-in-out infinite;animation:loading-dash 1.5s ease-in-out infinite;stroke-dasharray:90,150;stroke-dashoffset:0;stroke-width:2;stroke:var(--ti-loading-text-color);stroke-linecap:round}.tiny-loading__spinner svg{fill:var(--ti-loading-text-color)}.tiny-loading__parent-relative{position:relative!important}.tiny-loading__parent-hidden{overflow:hidden!important}.tiny-loading-fade-enter,.tiny-loading-fade-leave-active{opacity:0}@-webkit-keyframes loading-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes loading-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes loading-dash{0%{stroke-dasharray:1,200;stroke-dashoffset:0}50%{stroke-dasharray:90,150;stroke-dashoffset:-40px}100%{stroke-dasharray:90,150;stroke-dashoffset:-120px}}@keyframes loading-dash{0%{stroke-dasharray:1,200;stroke-dashoffset:0}50%{stroke-dasharray:90,150;stroke-dashoffset:-40px}100%{stroke-dasharray:90,150;stroke-dashoffset:-120px}}.tiny-icon-loading{font-size:var(--ti-common-font-size-1);line-height:1;vertical-align:text-top;-webkit-animation:rotating 2s linear infinite;animation:rotating 2s linear infinite}@-webkit-keyframes rotating{0%{-webkit-transform:rotateZ(0);transform:rotateZ(0)}100%{-webkit-transform:rotateZ(360deg);transform:rotateZ(360deg)}}@keyframes rotating{0%{-webkit-transform:rotateZ(0);transform:rotateZ(0)}100%{-webkit-transform:rotateZ(360deg);transform:rotateZ(360deg)}}";
styleInject(css_248z);

var script = {
  props: _toConsumableArray(props),
  setup: function setup$1(props, context) {
    return setup({
      props: props,
      context: context,
      renderless: renderless,
      api: api
    });
  }
};

var _hoisted_1 = {
  class: "tiny-loading__spinner"
};
var _hoisted_2 = {
  key: 0,
  class: "circular",
  viewBox: "25 25 50 50"
};
var _hoisted_3 = createElementVNode("circle", {
  class: "path",
  cx: "50",
  cy: "50",
  r: "24",
  fill: "none"
}, null, -1);
var _hoisted_4 = [_hoisted_3];
var _hoisted_5 = {
  key: 2,
  class: "tiny-loading__text"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock(Transition, {
    name: "tiny-loading-fade",
    onAfterLeave: _ctx.handleAfterLeave
  }, {
    default: withCtx(function () {
      return [withDirectives(createElementVNode("div", {
        class: normalizeClass(["tiny-loading tiny-loading__mask", [_ctx.state.customClass, {
          'is-fullscreen': _ctx.state.fullscreen
        }]]),
        style: normalizeStyle({
          backgroundColor: _ctx.state.background || ''
        })
      }, [createElementVNode("div", _hoisted_1, [!_ctx.state.spinner ? (openBlock(), createElementBlock("svg", _hoisted_2, _hoisted_4)) : (openBlock(), createBlock(resolveDynamicComponent(_ctx.state.spinner), {
        key: 1,
        class: "tiny-icon-loading"
      })), _ctx.state.text ? (openBlock(), createElementBlock("p", _hoisted_5, toDisplayString(_ctx.state.text), 1)) : createCommentVNode("", true)])], 6), [[vShow, _ctx.state.visible]])];
    }),
    _: 1
  }, 8, ["onAfterLeave"]);
}

script.render = render;

export { script as default };
